Commodity Class Reference
Financial instruments

Commodity base class. More...

`#include <ql/experimental/commodities/commodity.hpp>`

Inheritance diagram for Commodity:
[legend]

## Public Member Functions

| Commodity (const boost::shared_ptr< SecondaryCosts > &secondaryCosts)
const boost::shared_ptr< SecondaryCosts > & | secondaryCosts () const
const SecondaryCostAmounts & | secondaryCostAmounts () const
const PricingErrors & | pricingErrors () const
void | addPricingError (PricingError::Level errorLevel, const std::string &error, const std::string &detail="") const
Public Member Functions inherited from Instrument
virtual void | setupArguments (PricingEngine::arguments *) const
virtual void | fetchResults (const PricingEngine::results *) const
Real | NPV () const
| returns the net present value of the instrument.
Real | errorEstimate () const
| returns the error estimate on the NPV when available.
const Date & | valuationDate () const
| returns the date the net present value refers to.
template<typename T >
T | result (const std::string &tag) const
| returns any additional result returned by the pricing engine.
const std::map< std::string, boost::any > & | additionalResults () const
| returns all additional result returned by the pricing engine.
virtual bool | isExpired () const =0
| returns whether the instrument might have value greater than zero.
void | setPricingEngine (const boost::shared_ptr< PricingEngine > &)
| set the pricing engine to be used. More...
Public Member Functions inherited from LazyObject
void | update ()
void | recalculate ()
void | freeze ()
void | unfreeze ()
void | alwaysForwardNotifications ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()

## Protected Attributes

boost::shared_ptr< SecondaryCosts > | secondaryCosts_
PricingErrors | pricingErrors_
SecondaryCostAmounts | secondaryCostAmounts_
Protected Attributes inherited from Instrument
boost::shared_ptr< PricingEngine > | engine_
Real | NPV_
Real | errorEstimate_
Date | valuationDate_
std::map< std::string, boost::any > | additionalResults_
Protected Attributes inherited from LazyObject
bool | calculated_
bool | frozen_
bool | alwaysForward_

## Additional Inherited Members

Public Types inherited from Observer
typedef std::set< boost::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Protected Member Functions inherited from Instrument
void | calculate () const
virtual void | setupExpired () const
virtual void | performCalculations () const
Protected Member Functions inherited from LazyObject

## Detailed Description

Commodity base class.